<?php 
function revtext($txt) {
  if ($txt=="") return("");
  $ss = "opqFnLEXfgMRJdePrBiCUvtTDwsNKGHWmhOIjkVQaYbSxcylzAZu";
  $g=strlen($txt)/3;
  if (floor($g) != $g) return('-');
  $tt='';
  $t1=substr($txt,0,$g);
  $t2=substr($txt,$g,$g);
  $t3=substr($txt,$g+$g, $g);
  for ($i=0; $i<$g; $i++) {
     $x1=substr($t1,$i,1);
     $n1=strpos($ss,$x1,0)+1;
     $x2=substr($t2,$i,1);
     $n2=strpos($ss,$x2,0)+1;
     $d=substr($t3,$i,1);
     $n=$n1+$n2+31;
     if ($d<="z" && $d>="j") $n=$n-52;
     if ($d<="Z" && $d>="J") $n=$n+52;
     $tt=$tt . chr($n);
  }
  return($tt);
}

function covtext($txt) {
  $ss = "opqFnLEXfgMRJdePrBiCUvtTDwsNKGHWmhOIjkVQaYbSxcylzAZu";
  $s1 = "jklmnopqrstuvwxyz";
  $s2 = "JKLMNOPQRSTUVWXYZ";
  $s3 = "aIfgCDEbcABhiFGHde";
  $g=strlen($txt);
  $tt='';
  $t1='';
  $t2='';
  $t3='';
  for ($i=0; $i<$g; $i++) {
     $x=substr($txt,$i,1);
     $a=ord($x);
     if ($a>31 && $a<127) {
         $r=rand(1, 52);
         $d=rand(1, 16);
         $t1=$t1 . substr($ss,$r-1,1);
         $n=$a-31-$r;
         if ($n<1) {
            $n=$n+52;
            $t3=$t3 . substr($s1, $d-1, 1);
         } elseif ($n>52) {
             $n=$n-52;
             $t3=$t3 . substr($s2, $d-1, 1);
         } else $t3=$t3 . substr($s3, $d-1,1);
         $t2=$t2 . substr($ss,$n-1,1);
     }
   }

   $tt=$t1 . $t2 . $t3;
   return($tt);
}

function rrmdir($dir) { 
  $objects = scandir($dir); 
  foreach ($objects as $object) { 
   if ($object != "." && $object != "..") { 
    if (is_dir($dir."/".$object)) {rrmdir($dir."/".$object);} else {unlink($dir."/".$object);}
   } 
  }
  rmdir($dir); 
}

function readFolder() {   // read current folder not include subfolder
   $ofiles = array();
   $files = scandir(".");
   foreach($files as $key => $value){
     if ($value != "." && $value != "..") {if (!(is_dir($value))) array_push($ofiles, $value);}
   }
   return($ofiles);
}

function getDirContents($dir, $results = array()){
  $files = scandir($dir);
  foreach($files as $key => $value){
	if ($value != "." && $value != "..") {
	  $path = realpath($dir.DIRECTORY_SEPARATOR.$value);
	  if (is_dir($path)) {
		$results[$value] = getDirContents($path, $tmp);
	  } else {
		$results[$value] = [];  
	  }	
	}
  } 
  return($results); 
}

function readDST($dstfpath) {
  $ssdArr = array();  
  $dstArr = array();
  $fh = fopen($dstfpath, "r") or exit("Unable to open file!");
  fgets($fh);  // line 1 skip  
  $t = explode(":", fgets($fh));  if (trim($t[0])=="Data file name") $ssdArr['fname'] = trim($t[1]);
  fgets($fh);   // line 3 skip
  $t = explode(":", fgets($fh));  if (trim($t[0])=="Number of observations") $ssdArr['nobs'] = trim($t[1]);
  $t = explode(":", fgets($fh));  if (trim($t[0])=="Number of variables") $ssdArr['nvar'] = trim($t[1]);
  fgets($fh);  // line variables list
  $v = array();
  $nvar = trim($t[1]);
  for ($i = 0; $i < $nvar; $i++) {
	  $spliti = preg_split('/\s+/', trim(fgets($fh)));
	  array_push($v, $spliti[0]);
  }	  
  fgets($fh);fgets($fh);  // variables distribution and space line
  $tmp = array(); $n = -1; $y = 0;
  while (!feof($fh)) {
    $x = fgets($fh);  $x = substr($x, 0, strlen($x) - 1);
    if (trim($x) > "") {
	  $t = preg_split('/\s+/', $x);
	  if (in_array($t[0], $v) || substr($t[0],0,9) == "*********") {
		$n++;  
		if ($n > 0 && $n <= $nvar) {
			json_encode($tmp);	 $jsontmp = json_last_error_msg();
            if ($jsontmp == "No error") {$dstArr[$v[$n-1]] = $tmp;	
		    } else {$dstArr[$v[$n-1]] = array(array($jsontmp));}
		}		
        if ($t[0] == $v[$n]) $tmp = array();
		$y = 0;
	  } else {
		if ($y==0) {
			if (strpos($x, 'distribution') !== false) {$y = 1;
			} elseif (strpos($x, 'percent') !== false) {$y = 2;		
			} else $y = 3;
		}
		if ($y==1) {			
		    $z = preg_split('/\s+/', trim($x));
			if (count($z)==2) array_push($tmp, array($z[0],"","",$z[1]));
			if (count($z)==3) array_push($tmp, array($z[0],$z[1],"",$z[2]));
			if (count($z)==4) array_push($tmp, array($z[0],$z[1],$z[2],$z[3]));
		} elseif ($y==2) {
            array_push($tmp, array(substr($x,0,18), substr($x,18,9), substr($x,27)));			
		} else {
		    array_push($tmp, array($x));	
		}
      }
	}			
  }
  fclose($fh);
  return(array($dstArr, $ssdArr));
}

function readDST4newvar($dstfname, $dstArr = array()) {
  $fh = fopen($dstfname, "r") or exit("Unable to open file!");
  $tmp = array(); $n = -1; $y = 0;  $vnm = "";
  while (!feof($fh)) {
    $x = fgets($fh);  $x = substr($x, 0, strlen($x) - 1);
    $t = preg_split('/\s+/', $x);
	if (substr($x,0,1) > " " || feof($fh)) {
  	  $n++;  
	  if ($n > 0 && $vnm > " ") {
		 json_encode($tmp);	 $jsontmp = json_last_error_msg();
         if ($jsontmp == "No error") {$dstArr[$vnm] = $tmp;
		 } else {$dstArr[$vnm] = array(array($jsontmp));}
	  }		  
      if (substr($x,0,1) > " ") {$tmp = array(); $vnm = trim($t[0]);}
	  $y = 0;
	} else {
	  if (trim($x) > "") {
	    if ($y==0) {
			if (strpos($x, 'distribution') !== false) {$y = 1;
			} elseif (strpos($x, 'percent') !== false) {$y = 2;		
			} else $y = 3;
		}
		if ($y==1) {			
		    $z = preg_split('/\s+/', trim($x));
			if (count($z)==2) array_push($tmp, array($z[0],"","",$z[1]));
			if (count($z)==3) array_push($tmp, array($z[0],$z[1],"",$z[2]));
			if (count($z)==4) array_push($tmp, array($z[0],$z[1],$z[2],$z[3]));
		} elseif ($y==2) {
            array_push($tmp, array(substr($x,0,18), substr($x,18,9), substr($x,27)));			
		} else {
		    array_push($tmp, array($x));	
		}
	  }	
    }	
  }
  fclose($fh);
  return($dstArr);
}

?>
